#ifndef _MGABES_H
#define _MGABES_H

#define BES_HFILTER 	1
#define BES_VFILTER 	2
#define BES_ACC2XZOOM  	4
#define BES_DITHER 	8
#define BES_BW 		16
#define BES_IS_G400	32
#define BES_INTERLACED	64

#define BES_FRAME_A	0
#define BES_FIELD_A1	0
#define BES_FIELD_A2	1

#define BES_FRAME_B	2
#define BES_FIELD_B1	2
#define BES_FIELD_B2	3

#define BES_FRAME_AUTO	4

struct mga_bes_s;

void mgabes_init(struct mga_dev_s *mga);
void mgabes_set_window(struct mga_bes_s *bes, int x, int y, int width, int height);
void mgabes_set_source(struct mga_bes_s *bes, int width, int height,
		       u32 base_a, u32 base_b, int dataformat);
void mgabes_set_colorkey(struct mga_bes_s *bes, u32 chromakey);
void mgabes_set_frame(struct mga_bes_s *bes, int frame);
void mgabes_set_mode(struct mga_bes_s *bes, int mode);
void mgabes_activate(struct mga_bes_s* bes);
void mgabes_desactivate(struct mga_bes_s* bes);

/*
 * helper functions
 */
unsigned int mgabes_pitch_rounding(struct mga_bes_s *bes, int width);

#endif /* _MGABES_H */
