/***************************************************************************
                          buffer.cpp  -  description
                             -------------------
    begin                : Tue Dec 7 1999
    copyright            : (C) 1999 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <iostream.h>
#include <stdio.h>

#ifndef BUFFER_H
#define BUFFER_H
#include "buffer.h"
#endif

#ifndef OBJECTS_H
# define OBJECTS_H
#include "objects.h"
#endif

#include <assert.h>
/************************************************************************/
IBUFF::IBUFF()
{
	frame_count = 0;
	file_pattern = NULL;
} //end IBUFF()

void IBUFF::get_frame(blk_t &Y, blk_t &Cr, blk_t &Cb, STATS &mpstat)
{
	char filename_Y[150];
	char filename_U[150];
	char filename_V[150];

	sprintf(filename_Y, "%s%d%s", file_pattern, frame_count, ".Y");
	sprintf(filename_U, "%s%d%s", file_pattern, frame_count, ".U");
	sprintf(filename_V, "%s%d%s", file_pattern, frame_count, ".V");

	cout << filename_Y << endl;

	Yin.open(filename_Y);
	if (Yin.fail())
	{
		cout << "Opening Y failed" << endl;
		exit(1);
	}
	Crin.open(filename_V);
	if (Crin.fail())
	{
		cout << "Opening V failed" << endl;
		exit(1);
	}
	Cbin.open(filename_U);
	if (Cbin.fail())
	{
		cout << "Opening U failed" << endl;
		exit(1);
	}

	int horizontal_size = mpstat.get_horizontal_size();
	int vertical_size = mpstat.get_vertical_size();
	int color_horizontal_size = mpstat.get_color_horizontal_size();
	int color_vertical_size = mpstat.get_color_vertical_size();

// read frame
	//need to shift the values from 8-bits to 9-bits (not doing this right now)
	for(int j = 0; j < vertical_size; j++)
	{
		for(int i = 0; i < horizontal_size; i++)
		{
			Y[i][j] = Yin.get();//(((short)(Yin.get()))) << 1;
			assert(Y[i][j] >= 0);
		}
	}

	for(int j = 0; j < color_vertical_size; j++)
	{
		for(int i = 0; i < color_horizontal_size; i++)
		{
			Cr[i][j] = Crin.get();//(((short)(Crin.get()))) << 1;
			Cb[i][j] = Cbin.get();//(((short)(Cbin.get()))) << 1;
		}
	} //end for

	Yin.close();
	Crin.close();
	Cbin.close();
	
	frame_count++; //increment frame_count to point to next frame
}	// end get_frame()

void IBUFF::set_file_pattern(char *name)
{
	file_pattern = name;
}
/************************************************************************/
// OBUFF
OBUFF::OBUFF()
{
	bytes_written = 0;
	bits_in_buff = 8;

	//FIXME
	fout.open("out.m2v");
}// end OBUFF()

OBUFF::OBUFF(char *filename)
{
	bytes_written = 0;
	bits_in_buff = 8;

	fout.open(filename);
}
OBUFF::~OBUFF()
{
	byte_allign();
 	fout.close();
}
void OBUFF::put_bits(int value, BYTE_t size)
{
  u32 mask;

  mask = 1 << (size-1);

  for (int i=0; i<size; i++)
  {
    buffer <<= 1;

    if (value & mask)
      buffer |= 1;

    mask >>= 1; /* sele */
    bits_in_buff--;

    if (bits_in_buff==0) /* 8 bit buffer full */
    {
//			assert(buffer != 0xe);
      fout.put(buffer);
      bits_in_buff = 8;
      bytes_written++;
    }// end if
  }// end for

}//end put_bits()

void OBUFF::byte_allign(void)
{
	if(bits_in_buff < 8)
	{
		put_bits(0,bits_in_buff);
	} //end if
} //end byte_allign()










