/***************************************************************************
                          dct.cpp  -  description
                             -------------------
    begin                : Tue Dec 7 1999
    copyright            : (C) 1999 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <math.h>

#include <assert.h>
#include <iostream>

#ifndef MPEG2ENC_H
# define MPEG2ENC_H
#include "mpeg2enc.h"
#endif
	
 void dct(blk_t source, int dest[][8])
 {
 	double temp[8][8];
 	double cu, cv;
 	const double pi = 3.1415;
	static const double one_sqrt_two = (1 / sqrt(2));

	for(int i = 0; i < 8; i++)
	{
		for(int j = 0; j < 8; j++)
		{
			source[i][j] -= 128;
		}
	}


 // do dct on source
 for(int u = 0; u < 8; u++)
 {
 	for(int v = 0; v < 8; v++)
 	{
 		if(u == 0)
 			cu = one_sqrt_two;
 		else
 			cu = 1;
 			
 		if(v == 0)
 			cv =  one_sqrt_two;
 		else
 			cv = 1;
 		
 		temp[u][v] = 0;
 		
 		for(int x = 0; x < 8; x++)
 		{
			for(int y = 0; y < 8; y++)
 			{
				temp[u][v] += (source[x][y]) * cos( (((2 * x) + 1) * u * pi)/16 ) * cos( (((2*y) + 1) * v * pi)/16 );
 			}// end for y
 		} // end for x
 		
 		temp[u][v] *= ( (0.25) * cu * cv );
 		
 		// add 0.5 for correct rounding
 		if(temp[u][v] > 0)
 			temp[u][v] += 0.5;
 		else
 			temp[u][v] -= 0.5;
 			
 	} // end for u
 } // end for v

	// now set the values to dest
  for(int i = 0; i < 8; i++)
  {
  	for(int j = 0; j < 8; j++)
  	{
  		dest[i][j] = (int)temp[i][j];
  	}
  }

} // end dct()


// sample value for block
//	int source[8][8] = {
//											{70, 72, 70, 70, 72, 68, 68, 64},
//											{103, 101, 103, 100, 99, 97, 94, 94},
//											{132, 132, 132, 130, 129, 129, 125, 121},
//											{157, 157, 155, 154, 153, 150, 148, 145},
//											{168, 163, 164, 162, 163, 161, 161, 156},
//											{172, 170, 165, 166, 163, 163, 162, 158},
//											{174, 170, 167, 167, 164, 163, 164, 159},
//											{174, 173, 170, 167, 167, 166, 166, 160}
//										};


































