/***************************************************************************
                          extensions.h  -  description
                             -------------------
    begin                : Thu Jan 27 2000
    copyright            : (C) 2000 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


class PICTURE_CODING_EXT
{
	public:
	PICTURE_CODING_EXT();
	void write(void);

	private:
	static const BYTE_t extension_start_code = 0xb5; 						//8-bit
	static const BYTE_t extension_start_code_identifier = 0x08;	//4-bit
	BYTE_t f_code[2][2];																				//4-bit x 4
	BYTE_t intra_dc_precision;																	// 2-bit
	BYTE_t picture_structure;																		// 2-bit
	BYTE_t top_field_first;																			//1-bit
	BYTE_t frame_pred_frame_dct;																//1-bit
	BYTE_t concealment_motion_vectors;													//1-bit
	BYTE_t q_scale_type;																				//1-bit
	BYTE_t intra_vlc_format;																		//1-bit
	BYTE_t alternate_scan;																			//1-bit
	BYTE_t repeat_first_field;																	//1-bit
	BYTE_t chroma_420_type;																			//1-bit
	BYTE_t progressive_frame;																		//1-bit
	BYTE_t composite_display_flag;															//1-bit
	BYTE_t v_axis;																							//1-bit
	BYTE_t field_sequence;																			//3-bit
	BYTE_t sub_carrier;																					//1-bit
	BYTE_t burst_amplitude;																			//7-bit
	BYTE_t sub_carrier_phase;																		// 8-bit
};
/*********************************************************/

class SEQUENCE_EXTENSION
{
	public:
	SEQUENCE_EXTENSION();
	void write(void);

	private:
	static const BYTE_t extension_start_code = 0xb5;
	static const BYTE_t extension_start_code_identifier = 1; //4-bit
	BYTE_t profile_and_level_indication; //8-bit
	BYTE_t progressive_sequence; //1-bit
	BYTE_t chroma_format; //2-bit
/*
	Table 6-5 meaning of chrome_format
	chroma_format		meaning
	00							Reserved
	01							4:2:0
	10							4:2:2
	11							4:4:4
*/
	BYTE_t horizontal_size_extension; //2-bit
	BYTE_t vertical_size_extension; //2-bit
	u16 bit_rate_extension; //12-bit
	static const BYTE_t marker_bit = 1; //1-bit
	BYTE_t vbv_buffer_size_extension; //8-bit
	BYTE_t low_delay; //1-bit
	BYTE_t frame_rate_extension_n; //2-bit
	BYTE_t frame_rate_extension_d; //5-bit
};