/***************************************************************************
                          vlc.cpp  -  description
                             -------------------
    begin                : Wed Jan 5 2000
    copyright            : (C) 2000 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/

// Parts of the vlc code is from the MPEG software simulation group I will replace it soon

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "vlc_codes.h"

#include "vlc.h"
#include "mpeg2enc.h"
#include "buffer.h"

#include "assert.h"
#include "math.h"
//FIXME
extern STATS mpstat;
extern OBUFF outbuff;
extern IBUFF input;

void put_intra_block(BYTE_t cc, short predictor[], int *block_data)
{
	int dct_diff;
	
	dct_diff = block_data[0] - predictor[cc];
	predictor[cc] = block_data[0];

	put_DC_intra_vlc(cc, dct_diff);

	put_AC_vlc(block_data, 0, 1);

} // end put_intra_block()

/*****************************************************************************************/
void put_DC_intra_vlc(BYTE_t cc, int value)
{
	int size = 0;
	int temp;
	int abs_value;

	if(value < 0)
		abs_value = value * -1;
	else
		abs_value = value;

	while (abs_value != 0)
	{
		abs_value >>= 1;
		size++;
	}

	if (cc == 0)
	{
		outbuff.put_bits(dct_dc_size_luminance[size].vlcode, dct_dc_size_luminance[size].length);
	} //end if
	else
	{
		outbuff.put_bits(dct_dc_size_chrominance[size].vlcode, dct_dc_size_chrominance[size].length);
	} //end else

	if(size > 0)
	{
		if(value >= 0)
			abs_value = value;
		if(value < 0)
			abs_value = value + ((1<<size) -1);

		outbuff.put_bits(abs_value, size);
	} //end if
} //end write_DC_intra_vlc()

/*****************************************************************************************/
void put_AC_coeff(int run, int level, BYTE_t intra_vlc_format, BYTE_t macroblock_intra)
{
	VLCtable_t *table;
	int length = 0;
	int sign = 0;
	int abs_level;

	assert(intra_vlc_format != 1);
	assert(level != 0);
	assert(run >= 0);
	assert(run < 63);
	assert(level < 2048);
	assert(level > -2049);

	if(level < 0)
	{
		abs_level = level * -1;
		sign = 1;
	}
	else
	{
		abs_level = level;
		sign = 0;
	}

	assert(abs_level != 0);
	//select table
	//check if run/level in table
		//if in table write code and sign bit
		//else use escape coding

	if( (intra_vlc_format == 1) && (macroblock_intra == 1) )
	{
		//FIXME when i have table B.15 in
		table = NULL;
	}
	else
	{
		if( (abs_level < 40) && (run < 2) )
		{
			table = &dct_coeff_zero[run][abs_level-1];
//			table = &dct_code_tab1a[run][abs_level-1];
			length = table->length;
		} //end if
		else if( (run<32) && (abs_level<6) )
		{
			table = &dct_coeff_zero2[run-2][abs_level-1];
//			table = &dct_code_tab2a[run-2][abs_level-1];
			length = table->length;
		} //end else
	} //end else

	if(length > 0) //VLC exist in table
	{
		assert(length > 0);
		outbuff.put_bits(table->vlcode, length);
		outbuff.put_bits(sign,1);
	} //end if
	else //no VLC for this run/level use escape coding
	{
		outbuff.put_bits(1,6); //escape code
		outbuff.put_bits(run,6);
		outbuff.put_bits(level,12);
	} //end else

} //end put_AC_coeff()

/*****************************************************************************************/
void put_AC_vlc(int *block_data, BYTE_t intra_vlc_format, BYTE_t macroblock_intra)
{
	int run = 0;
	int level;

	for(int i = 1; i < 64; i++)	
	{
		if(block_data[i] == 0)
		{
			run++;
		}
		else	
		{
			level = block_data[i];
			assert(level != 0);
			put_AC_coeff(run, level, intra_vlc_format, macroblock_intra);
			run = 0;
		} //end if
	} //end for

	//put end of block
	if( (intra_vlc_format == 1) && (macroblock_intra == 1) )
	{
		//from table B.15
		outbuff.put_bits(6,4);
	} // end if
	else
	{
		//from table B.14
		outbuff.put_bits(2,2);
	} //end else

} // end put_AC_vlc()

/*****************************************************************************************/
//FIXME need to fix macroblock_excape and macroblock_address_increment
void putVLC_address_increment(const u16 increment)
{
	u16 mod_value;

	mod_value = increment % 33;
	
	assert(mod_value < 34);
	outbuff.put_bits(macroblock_address_increment[mod_value].vlcode, macroblock_address_increment[mod_value].length);
//	cout <<  macroblock_address_increment[increment].vlcode << " " <<  macroblock_address_increment[increment].length << endl;
}
/*****************************************************************************************/
void putVLC_macroblock_type()
{
	outbuff.put_bits(mblock_type[0][0].vlcode, mblock_type[0][0].length);
}
/*****************************************************************************************/
