
/*
 *
 * Copyright (C) 2000  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */



#ifndef __CODEC_AUDIO_H__
#define __CODEC_AUDIO_H__

#include <sys/types.h>

#include <oms/buf.h>
#include <oms/plugin/id.h>


typedef struct {
// open codec
	int (*open)		(u_int id, u_int type);
// close codec
	int (*close)		(u_int id, u_int type);
// read codec
        int (*read)             (buf_t *buf, buf_entry_t *buf_entry);
// write codec
        int (*write)            (buf_t *buf, buf_entry_t *buf_entry);

// set operational status (PLAY, PAUSE, STOP)
	int (*set_status)	(u_int stats);
// set attributes (audio, video, spu)
	int (*set_attributes)	(u_int id, void *attr);
} plugin_codec_audio_t;



// audio attributes
typedef struct {
	int mode;		// 0=ac3, 1=mpeg, 2=lpcm
	int bits;		// 0=16bit, 1=20bitm 2=24bit
	int freq; 		// 0=44.1kHz 1=48kHz 2=96kHz 3=22.05kHz 4=32kHz
	int stream;		// 0-7
	int volume;		// 0-100
} plugin_codec_attr_audio_t;

#endif
