
/*
 *
 * Copyright (C) 2000  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */


#ifndef __CODEC_SPU_H__
#define __CODEC_SPU_H__

#include <sys/types.h>


typedef struct {
// open codec
	int (*open)		();
// close codec
	int (*close)		();
// read codec
        int (*read)             (buf_t *buf, buf_entry_t *buf_entry);
// write codec
        int (*write)            (buf_t *buf, buf_entry_t *buf_entry);

// set operational status (PLAY, PAUSE, STOP)
	int (*set_status)	(u_int stats);
// set attributes (audio, video, spu)
	int (*set_attributes)	(u_int id, void *attr);
} plugin_codec_spu_t;


/**
 * SPU attributes
 **/

typedef struct {
	int num;		// number of SPU 0-31, 63=off
	char *clut;		// Color Lookup Table (palette)
} plugin_codec_attr_spu_t;

#endif
