
/*
 *
 * Copyright (C) 2000  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */


#ifndef __CODEC_VIDEO_H__
#define __CODEC_VIDEO_H__

#include <sys/types.h>


typedef struct {
// open codec
	int (*open)		(u_int id, u_int type);
// close codec
	int (*close)		(u_int id, u_int type);
// read codec
        int (*read)             (buf_t *buf, buf_entry_t *buf_entry);
// write codec
        int (*write)            (buf_t *buf, buf_entry_t *buf_entry);

// set operational status (PLAY, PAUSE, STOP)
	int (*set_status)	(u_int stats);
// set attributes (audio, video, spu)
	int (*set_attributes)	(u_int id, void *attr);
} plugin_codec_video_t;


/**
 * Video attributes
 **/

typedef struct {
	int mode;		// 0=VOB, 1=VCD, 2=MPG
	int fps;		// 0=50Hz, 1=60Hz	
	int aspect_mode;	// 0=NORMAL, 1=PANSCAN, 2=LETTERBOX
	int aspect_output;	// 0=4:3, 3=16:9
	int tv_system;		// 0=NTSC, 1=NTSC60, 2=PAL, 3=PALM, 4=PALM60, 5=PALN, 6=PALNc, 7=PAL60
} plugin_codec_attr_video_t;

#endif
