
/*
 *
 * Copyright (C) 1999  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */


#ifndef __OUTPUT_VIDEO_H__
#define __OUTPUT_VIDEO_H__

#include <sys/types.h>
#include <oms/plugin/id.h>

typedef struct plugin_output_video_struct {
// private data structure
	void *priv;
// init output
	int (*init)	(struct plugin_output_video_struct *plugin);
// exit output
	int (*exit)	(struct plugin_output_video_struct *plugin);
// open
	int (*open)	(struct plugin_output_video_struct *plugin);
// close
	int (*close)	(struct plugin_output_video_struct *plugin);
// write video (rgb)
	int (*write_rgb)	(char *data, u_int len);
// write video (yuv)
	int (*write_yuv)	(char *data, u_int len);
// write subpicture
	int (*write_spu)	(char *data, u_int len);
} plugin_output_video_t;

#endif
