#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

#include <oms/plugin.h>

extern plugin_decaps_t *plugin_init (void *foo);

int fd;

int foo_read (buf_t *buf, buf_entry_t *buf_entry)
{
        return (int) read (fd, (void *) buf_entry->mem, (size_t) buf_entry->mem_len);
}

int foo_write (buf_t *buf, buf_entry_t *buf_entry)
{
	write (1, buf_entry->mem, buf_entry->mem_len);
	free (buf_entry->mem);

	return 0;
}

int main (int argc, char *argv[])
{
	plugin_decaps_t *decaps;
	buf_t  buf;

	if (argc < 2) {
		fprintf (stderr, "usage %s <filename>\n", argv[0]);
		exit (-1);
	}

	decaps = plugin_init (NULL);
	decaps->read = foo_read;
	decaps->write = foo_write;
	decaps->blocksize = 2256;

	fd = open (argv[1], O_RDONLY);

	while (1) {
		decaps->decaps (&buf);
	}
	
	plugin_exit ();
	close (fd);

	return 0;
}


