#include <stdio.h>
#include <stdlib.h>
 
#ifndef HAVE_LINUX_RAW_H
int main()
{
	fprintf(stderr,"support for linux raw devices not compiled in.\n");
	exit(EXIT_FAILURE);
}
#else

#include <errno.h>
 
#include "linux_raw.h"
int main (int argc, char *argv[])
{
	int fd_raw;
	char *buf;
#define BUF_COUNT 10   
#define BUF_SIZE 2048
	int i;
   
	if(argc!=2) {
		fprintf(stderr,"Usage: %s <device>\n", argv[0]);
		exit(EXIT_FAILURE);
	}

// allocate buffer
	if(!(buf=valloc(BUF_SIZE))) {
		fprintf(stderr,"could not valloc %d bytes: %s\n",BUF_SIZE,strerror(errno));
		exit(EXIT_FAILURE);
	}

// open raw device
	if((fd_raw = raw_open(argv[1])) < 0) {
		fprintf(stderr,"raw device for `%s': could not be opened\n",argv[1],strerror(errno));
		exit(EXIT_FAILURE);
	}
	fprintf(stderr,"raw device for `%s': successfully opened\n",argv[1]);

// read from raw device
	for (i=0; i!=BUF_COUNT; ++i) {
		if(read(fd_raw,buf,BUF_SIZE)!=BUF_SIZE) {
			fprintf(stderr,"raw device for `%s': could not read %d bytes\n",argv[1],BUF_SIZE);
		exit(EXIT_FAILURE);
		}
		fprintf(stderr,"raw device for `%s': succecssfully read %d bytes\n",argv[1],BUF_SIZE);
	}

// close raw device
	if (raw_close(fd_raw)) {
		fprintf(stderr,"error closing raw device for `%s':
%s\n",argv[1],strerror(errno));
		exit(EXIT_FAILURE);
	}
	fprintf(stderr,"raw device for `%s': successfully closed\n",argv[1]);
   
	exit(EXIT_SUCCESS);
}
#endif
