/*  Open Media System - oms
 * 
 *  skin selection page in configuration dialog
 *
 *  Copyright (C) 2000  Thomas Mirlacher, Guenter Bartsch
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "config_store.h"

#include "config_skin.h"
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dirent.h>
#include <config.h>
#include "skin.h"

GtkWidget *skinlist, *skinentry ;
gint      nSelectedRow=0;
GList     *pSkinList;

void config_skin_apply ()
{
  gchar *str_skin=NULL; 

  gtk_clist_get_text  (GTK_CLIST(skinlist), nSelectedRow, 0, &str_skin);

  cfg_set_val_string ("skin", str_skin);

  load_skin (str_skin);
  apply_panel_skin ();
}

/*
 * scan skin directory for skins
 */
void setup_skinlist () 
{
  gchar *strlist[2] = { NULL, NULL } ;
  DIR *skindir;
  struct dirent *direntry;
  int i;

  gtk_clist_clear ((GtkCList *) skinlist);

  skindir = opendir (OMS_SKINDIR);
  
  if (!skindir) 
    {
      fprintf (stderr, "Cannot open skindir %s\n", OMS_SKINDIR);
      return;
    }

  i=0;
  while ((direntry = readdir (skindir)) != NULL)
    {
      if ((strcmp (direntry->d_name,".")) && (strcmp (direntry->d_name,"..")))
	{

	  // fprintf (stderr, "skin found : %s\n", direntry->d_name);
	  strlist[0] = direntry->d_name;
	  gtk_clist_append( GTK_CLIST (skinlist), (gchar **) &strlist);

	  if (!strcmp (direntry->d_name, cfg_get_defval_string ("skin","default")))
	    gtk_clist_select_row (GTK_CLIST (skinlist), i, 0);
	  
	  i++;
	}
    }

  closedir (skindir);

}

void skin_selection_made(GtkWidget *widget,
		    gint row,
		    gint column,
		    GdkEventButton *event,
		    gpointer data)
{
  nSelectedRow = row;
}


GtkWidget *create_skin_page ()
{

  GtkWidget *vbox, *scroller ;

  nSelectedRow = -1;

  vbox = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox);

  /*
   * the List
   */

  scroller = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroller),
				  GTK_POLICY_AUTOMATIC,
				  GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize (scroller, 150, 200);
  gtk_box_pack_start (GTK_BOX (vbox), scroller, TRUE, TRUE, 5);
  gtk_widget_show (scroller);
  
  skinlist = gtk_clist_new (1);
  gtk_widget_show (skinlist);

  gtk_signal_connect_object (GTK_OBJECT (skinlist), "select_row",
			     GTK_SIGNAL_FUNC(skin_selection_made),
			     NULL);
  
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW(scroller), skinlist);

  setup_skinlist () ;

  return vbox;

}





